VERSION 5.00
Object = "{0D452EE1-E08F-101A-852E-02608C4D0BB4}#2.0#0"; "FM20.DLL"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Icon"
   ClientHeight    =   1170
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   1440
   LinkTopic       =   "text1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1170
   ScaleWidth      =   1440
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   480
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.Timer Timer1 
      Left            =   360
      Top             =   360
   End
   Begin MSForms.Image Image1 
      Height          =   735
      Left            =   240
      Top             =   120
      Width           =   975
      AutoSize        =   -1  'True
      Size            =   "1720;1296"
   End
   Begin VB.Menu mnuImage1 
      Caption         =   "Image"
      Begin VB.Menu mnuSearch1 
         Caption         =   "Search"
      End
      Begin VB.Menu mnuAddIcon1 
         Caption         =   "AddIcon"
      End
      Begin VB.Menu mnuChangeIcon1 
         Caption         =   "ChangeIcon"
      End
      Begin VB.Menu mnuDeleteIcon1 
         Caption         =   "DeleteIcon"
      End
   End
   Begin VB.Menu mnuAbout1 
      Caption         =   "About"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem Program: Taskbar3 -- add\delete\modify taskbar icons w/ first clock icon containing mouseover time display. pd 2002.

Option Explicit ' force variable declarations
Option Base 0 ' set all arrays to start at zero.
DefInt A-Z ' set all variables to integer

Private Type NotifyIconData
 cbSize As Long
 hWnd As Long
 uID As Long
 uFlags As Long
 uCallbackMessage As Long
 hIcon As Long
 szTip As String * 64
End Type

' Structure for the Shell_NotifyIcon function's lpData parameter
Dim udtNotify As NotifyIconData

' Variables for current icons
Dim IconFilename As String
Dim IconNumber As Long

' Sends a message to the system to add, modify, or delete a taskbar icon.
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage&, lpData As NotifyIconData) As Long

Public Function AddIconToTray(IconHandle&) As Boolean
 udtNotify.cbSize = Len(udtNotify)
 udtNotify.hWnd = 0&
 udtNotify.uID& = IconNumber
 udtNotify.uFlags& = 7
 udtNotify.uCallbackMessage = 0&
 udtNotify.hIcon& = IconHandle&
 udtNotify.szTip = "Time:" + Chr$(0)
 If Shell_NotifyIcon&(0&, udtNotify) Then AddIconToTray = True
End Function

Public Function ModifyIcon(IconHandle&) As Boolean
 udtNotify.uID& = IconNumber
 udtNotify.uFlags& = 2
 udtNotify.hIcon& = IconHandle&
 If Shell_NotifyIcon&(1&, udtNotify) Then ModifyIcon = True
End Function

Public Function ModifyIconTip() As Boolean
 udtNotify.uID& = 1&
 udtNotify.uFlags& = 4
 udtNotify.szTip = "Time: " + Time$ + Chr$(0)
 If Shell_NotifyIcon&(1&, udtNotify) Then ModifyIconTip = True
End Function
 
Public Function DeleteIcon() As Boolean
 udtNotify.uID& = IconNumber
 If Shell_NotifyIcon&(2&, udtNotify) Then DeleteIcon = True
End Function
 
Private Sub Form_Load()
 Call Check_Filename
 ' reset current icon number
 IconNumber = 1&
 ' add icon
 If AddIconToTray(LoadPicture("c:\temp\clock05.ico")) = False Then
    MsgBox ("Couldn't load clock05.ico")
    End
 End If
 ' reset timer
 Timer1.Interval = 1000
End Sub

Private Sub Check_Filename()
 On Local Error GoTo ErrorRoutine ' reset error trap
 Open "c:\temp\clock05.ico" For Input As #1
 Close #1
 Exit Sub
ErrorRoutine:
 MsgBox ("Can't find 'clock05.ico' -- please put it in c:\temp\")
 End
End Sub

Private Sub Form_Unload(Cancel As Integer)
 ' delete all icons
 Do
    If IconNumber = 0 Then
       Exit Do
    End If
    DeleteIcon
    IconNumber = IconNumber - 1&
 Loop
 End
End Sub

Private Sub mnuAbout1_Click()
 MsgBox ("Public domain 2002.")
End Sub

Private Sub mnuAddIcon1_Click()
 If Len(IconFilename) Then
    ' increment icon number
    IconNumber = IconNumber + 1&
    ' add icon
    If AddIconToTray(LoadPicture(IconFilename)) = False Then
       MsgBox ("Couldn't add icon file.")
       IconNumber = IconNumber - 1&
    End If
 End If
End Sub

Private Sub mnuChangeIcon1_Click()
 If Len(IconFilename) Then
    ' change current icon
    If ModifyIcon(LoadPicture(IconFilename)) = False Then
       MsgBox ("Couldn't modify icon file.")
    End If
 End If
End Sub

Private Sub mnuDeleteIcon1_Click()
 If IconNumber > 1& Then
    ' delete current icon
    DeleteIcon
    ' decrement iconnumber
    IconNumber = IconNumber - 1&
 End If
End Sub

Private Sub mnuSearch1_Click()
 ' get a graphics file
 CommonDialog1.filename = ""
 CommonDialog1.Filter = "Icon Files (*.ico)|*.ico"
 CommonDialog1.ShowOpen
 If CommonDialog1.filename <> "" Then
    If LCase$(Right$(CommonDialog1.filename, 4)) = ".ico" Then
       ' store filename
       IconFilename = CommonDialog1.filename
       ' display image
       Image1.Picture = LoadPicture(IconFilename)
    End If
 End If
End Sub

Private Sub Timer1_Timer()
 ModifyIconTip
End Sub
